// ==================================================
//	myMime.h
//	Copyright (C) 1996 Mizutori Tetsuya, August 20, 1996, October 7, 1996.
// ==================================================
//	This document is pretty-printed in 10-point Geneva font.

//#define MIME_ENCODE	1
#define MIME_DECODE	1


#ifdef MIME_ENCODE
static unsigned long	CalcMimeEncodeLength(
			unsigned long		textSize );

void	MimeEncode(
			Handle			textH,
			unsigned long *		textSize );

void	MimeEncodeJIS(
			Handle			textH,
			unsigned long *		textSize );

unsigned long MimeEncodeText(
			const unsigned char *	pStart,
			const unsigned long	pLen,
			unsigned char *		qStart,
			unsigned long *		qLen );

static void	Base64EncodeBody(
			const unsigned char *	p,
			const unsigned long	pLen,
			unsigned char *		q,
			unsigned long *		qLen );

static void	Base64Encode324(
			const unsigned char *	p3,
			const unsigned long	pLen,
			unsigned char *		q4,
			unsigned long *		qLen );

#endif // MIME_ENCODE


#ifdef MIME_DECODE
void	MimeDecode(
			Handle			textH,
			unsigned long *		textSize );

unsigned long MimeDecodeText(
			const unsigned char *	pStart,
			const unsigned long	pLen,
			unsigned char *		qStart,
			unsigned long *		qLen );

static void	Base64DecodeBody(
			const unsigned char *	p,
			const unsigned long	pLen,
			unsigned char *		q,
			unsigned long *		qLen );

static void	Base64Decode423(
			const unsigned char *	p4,
			const unsigned long	pLen,
			unsigned char *		q3,
			unsigned long *		qLen );
#endif // MIME_DECODE

static Boolean	IsCharBase64(
			unsigned char		theChar );

static Boolean	FindToken(
			const unsigned char *	pStart,
			const unsigned long	pLen,
			const unsigned char *	token,
			const unsigned long	tokenLen,
			unsigned long *		index );

static Boolean	IsSameString(
			const unsigned char *	strA,
			const unsigned long	strALen,
			const unsigned char *	strB,
			const unsigned long	strBLen );

#ifdef MIME_ENCODE
static unsigned long	TextAppend(
			Handle			textH,
			unsigned long *		textSize,
			unsigned char *		pStart,
			unsigned char *		pEnd );
#endif // MIME_ENCODE

// end of definition
